import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/mapping/field-created-by.ts";
import { T } from '@contentlayer/utils/effect';
export const fieldCreatedBy = {
    getFieldDef: () => T.succeed({
        type: 'nested_unnamed',
        typeDef: {
            _tag: 'NestedUnnamedTypeDef',
            extensions: {},
            fieldDefs: [
                {
                    name: 'type',
                    type: 'enum',
                    options: ['person', 'bot'],
                    description: 'The user type',
                    isSystemField: false,
                    default: undefined,
                    isRequired: false,
                },
                {
                    name: 'name',
                    type: 'string',
                    description: 'The user name',
                    isSystemField: false,
                    default: undefined,
                    isRequired: false,
                },
                {
                    name: 'avatarUrl',
                    type: 'string',
                    description: 'The user avatar',
                    isSystemField: false,
                    default: undefined,
                    isRequired: false,
                },
                {
                    name: 'email',
                    type: 'string',
                    description: 'User email address, only if the user is a person and the integration has user capabilities to access email addresses.',
                    isSystemField: false,
                    default: undefined,
                    isRequired: false,
                },
                {
                    name: 'workspace',
                    type: 'string',
                    description: 'User workspace owner, only if the user is a bot',
                    isSystemField: false,
                    default: undefined,
                    isRequired: false,
                },
            ],
        },
    }, fileName_1 + ":8:14"),
    getFieldData: ({ propertyData }) => {
        const user = propertyData;
        return T.succeed({
            type: user.type,
            name: user.name,
            avatarUrl: user.avatar_url,
            ...('person' in user
                ? {
                    email: user.person.email,
                }
                : {}),
            ...('bot' in user
                ? {
                    workspace: user.bot.workspace_name,
                }
                : {}),
        }, fileName_1 + ":62:21");
    },
};
//# sourceMappingURL=field-created-by.js.map